=== debian/changelog ===
cvc5 (1.0.5-3) unstable; urgency=medium

  * Post-NEW source-only upload

 -- Scott Talbert <swt@techie.net>  Fri, 23 Jun 2023 15:50:35 -0400

cvc5 (1.0.5-2) unstable; urgency=medium

  * Build Python bindings (Closes: #1034268)

 -- Scott Talbert <swt@techie.net>  Thu, 22 Jun 2023 15:58:34 -0400

cvc5 (1.0.5-1) unstable; urgency=medium

  * Update to new upstream release 1.0.5 (Closes: #1037616)
  * Update Standards-Version to 4.6.2 (no changes needed)
  * Rules-Requires-Root: no

 -- Scott Talbert <swt@techie.net>  Tue, 20 Jun 2023 12:11:06 -0400
